define("index", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class PageBuilder {
        test() {
            console.log(`I'm fine and on npm!`);
        }
        constructor(pageSize) {
            this.size = 0;
            this.pageSize = pageSize;
        }
        getTotalPages() {
            return Math.ceil(this.size / this.pageSize);
        }
        setSize(size) {
            this.size = size;
        }
        getPage(page, elements) {
            this.size = elements.length;
            return {
                first: page === 0,
                last: page === this.getTotalPages(),
                number: page,
                numberOfElements: this.getPageSize(),
                size: this.getPageSize(),
                sort: '',
                totalElements: this.getSize(),
                totalPages: this.getTotalPages(),
                content: elements.slice(this._startIndex(page), this._endIndex(page) + 1)
            };
        }
        _startIndex(page) {
            if (page === 0) {
                return 0;
            }
            else {
                return this.getPageSize() * page;
            }
        }
        _endIndex(page) {
            return this._startIndex(page) + this.getPageSize() - 1;
        }
        getSize() {
            return this.size;
        }
        getPageSize() {
            return this.pageSize;
        }
    }
    exports.default = PageBuilder;
});
