class PageBuilder {

	size: number;
	pageSize: number;

	test() {
		console.log(`I'm fine and on npm!`);
	}

	constructor(pageSize: number) {
		this.size = 0;
		this.pageSize = pageSize;
	}

	getTotalPages() {
		return Math.ceil(this.size / this.pageSize);
	}

	setSize(size : number) {
		this.size = size;
	}

	getPage<T>(page : number, elements : T[]) {
		this.size = elements.length;

		return {
			first: page === 0,
			last: page === this.getTotalPages(),
			number: page,
			numberOfElements: this.getPageSize(),
			size: this.getPageSize(),
			sort: '',
			totalElements: this.getSize(),
			totalPages: this.getTotalPages(),
			content: elements.slice(this._startIndex(page), this._endIndex(page) + 1)
		};
	}

	_startIndex(page: number) {
		if (page === 0) {
			return 0;
		} else {
			return this.getPageSize() * page;
		}
	}

	_endIndex(page : number) {
		return this._startIndex(page) + this.getPageSize() - 1;
	}

	getSize() {
		return this.size;
	}

	getPageSize() {
		return this.pageSize;
	}
}


export default PageBuilder;
